var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SocketDaemonV2 = function () {
  function SocketDaemonV2(daemonURL) {
    _classCallCheck(this, SocketDaemonV2);

    this.daemonURL = daemonURL + '/v2';
  }

  // init tries an HEAD


  _createClass(SocketDaemonV2, [{
    key: 'init',
    value: function init() {
      return fetch(this.daemonURL + '/pkgs/tools/installed', {
        method: 'HEAD'
      }).then(function (res) {
        if (res.status !== 200) {
          throw Error('v2 not available');
        }
        return res;
      });
    }

    // installedTools uses the new v2 apis to ask the daemon a list of the tools already present in the system

  }, {
    key: 'installedTools',
    value: function installedTools() {
      return fetch(this.daemonURL + '/pkgs/tools/installed', {
        method: 'GET'
      }).then(function (res) {
        return res.json();
      });
    }

    // installTool uses the new v2 apis to ask the daemon to download a specific tool on the system
    // The expected payload is
    // {
    //   "name": "avrdude",
    //   "version": "6.3.0-arduino9",
    //   "packager": "arduino",
    //   "url": "https://downloads.arduino.cc/...", // system-specific package containing the tool
    //   "signature": "e7Gh8309...",  // proof that the url comes from a trusted source
    //   "checksum": "SHA256:90384nhfoso8..." // proof that the package wasn't tampered with
    // }

  }, {
    key: 'installTool',
    value: function installTool(payload) {
      return fetch(this.daemonURL + '/pkgs/tools/installed', {
        method: 'POST',
        body: JSON.stringify(payload)
      }).then(function (res) {
        return res.json().then(function (json) {
          if (!res.ok) {
            var error = Object.assign({}, json, {
              status: res.status,
              statusText: res.statusText
            });

            return Promise.reject(error);
          }
          return json;
        });
      });
    }
  }]);

  return SocketDaemonV2;
}();

export default SocketDaemonV2;